package com.flow.behavior;

import com.flow.flowable.cmd.RecordActivityDeleteReasonCmd;
import lombok.extern.slf4j.Slf4j;
import org.flowable.common.engine.api.async.AsyncTaskInvoker;
import org.flowable.engine.ManagementService;
import org.flowable.engine.delegate.DelegateExecution;
import org.flowable.engine.impl.bpmn.http.DefaultBpmnHttpActivityDelegate;
import org.flowable.engine.impl.util.CommandContextUtil;
import org.flowable.http.common.api.HttpResponse;

import java.util.concurrent.CompletableFuture;

@Slf4j
public class CustomHttpServiceTaskActivityBehavior extends DefaultBpmnHttpActivityDelegate {

    @Override
    public CompletableFuture<ExecutionData> execute(DelegateExecution execution, AsyncTaskInvoker taskInvoker) {
        return super.execute(execution, taskInvoker);
    }

    @Override
    public void afterExecution(DelegateExecution execution, ExecutionData result) {
        HttpResponse response = result.getResponse();
        if (response.getStatusCode() >= 400) {
            log.error("HttpServiceTask error: {}", response.getBody());
            // ManagementService managementService = CommandContextUtil.getProcessEngineConfiguration().getManagementService();
            // managementService.executeCommand(new RecordActivityDeleteReasonCmd(execution.getId(), execution.getCurrentActivityId(), response.getBody()));
        }
        super.afterExecution(execution, result);
    }
}
